"""
/***************************************************************************
 LumigisDockWidget
                                 A QGIS plugin
 Gestion du patrimoine éclairage public
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2019-12-04
        git sha              : $Format:%H$
        copyright            : (C) 2019 by Jean-Marie Arsac
        email                : jmarsac@azimut.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from qgis.core import Qgis, QgsEditError, QgsProject, QgsVectorLayer, edit
from qgis.PyQt import QtGui, QtWidgets, uic
from qgis.PyQt.QtCore import Qt, QTime, QVariant, pyqtSignal
from qgis.PyQt.QtWidgets import QApplication, QTreeWidgetItem
from qgis.utils import iface

from lumigis.dlg_util import DlgUtil
from lumigis.fea_util import FeaUtil
from lumigis.lumigis_config import LumigisConfig
from lumigis.lumigis_layers import LumigisLayersConst
from lumigis.place_point_tool2 import PlacePointTool

# from PyQt5 import QtCore, QtWidgets


FORM_CLASS, _ = uic.loadUiType(
    os.path.join(os.path.dirname(__file__), "lumigis_dockwidget.ui")
)


class LumigisDockWidget(QtWidgets.QDockWidget, FORM_CLASS):
    closingPlugin = pyqtSignal()

    def __init__(self, iface, dbutil, lumigis_layers, mode: str = "consultation"):
        """Constructor."""
        parent = None
        super(LumigisDockWidget, self).__init__(parent)
        # Set up the user interface from Designer.
        # After setupUI you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://doc.qt.io/qt-5/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.setupUi(self)

        self.iface = iface
        self.mode = mode
        self.treeview_mode = LumigisConfig.gis_config()["treeview_mode"]

        self.globalAdherent = ""
        self.globalInsee = 0
        self.globalSupport = ""
        self.globalArmoire = ""
        self.globalDepart = ""
        self.globalFoyer = ""

        self.globalIntervention = ""
        self.globalInterventionId = 0

        self.globalSupportId = 0
        self.globalArmoireId = 0
        self.globalDepartId = 0
        self.globalFoyerId = 0

        self.idInconnu = "?"
        self.currentIdnom = ""
        self.currentId = 0
        self.currentFeature = None
        self.currentSymbol = None

        self.currentTreeWidget = None
        self.db_util = dbutil
        self._lumigis_layers = lumigis_layers
        self.db_util_privilege = None
        self._privilege_schema = ""
        self._privilege_table = "armoires"
        self.globalSourceId = 0

    def setMode(self, mode):
        self.mode = mode

    def setQuery(self, query):
        self._query = query

    def setDbPrivilege(self, privilege):
        self.db_util_privilege = privilege

    def setDbUtil(self, dbutil):
        self._db_util = dbutil

    def set_rgx_str_sinfoni(self, myregex):
        self._rgx_str_sinfoni = myregex

    def closeEvent(self, event):
        self.closingPlugin.emit()
        event.accept()

    def enable_adherent(self, insee: int = 0):
        try:
            self.comboBoxAdherent.setCurrentIndex(1)
        except Exception as e:
            print(str(e))

    def update_comboboxes_for_adherent(self, insee, query):
        self.comboBoxAdherent.setEnabled(False)
        self.lineEditInsee.setEnabled(False)
        self.comboBoxIntervention.setEnabled(False)

        self.comboBoxArmoire_etat.setEditable(True)
        self.comboBoxArmoire_etat.setMaxCount(self.comboBoxArmoire_etat.count())
        self.comboBoxArmoire_etat.setMaxVisibleItems(15)

    def on_comboboxadherent_current_index_changed(self, current_index):
        self.globalInsee = 0
        if current_index >= 0:
            idnom = self.comboBoxAdherent.currentText()

            if current_index > 0 and idnom != "":
                self.globalAdherent = idnom
                try:
                    sql = "SELECT value_data FROM metadata WHERE key_data = 'INSEE'"
                    query = self.db_util.query
                    if query.exec(sql):
                        if query.first():
                            self.lineEditInsee.setText(query.value("value_data"))
                            self.globalInsee = int(query.value("value_data"))
                except Exception as e:
                    print(str(e))
                self.treeWidgetSupports.clear()
                self.treeWidgetAppareils.clear()
                iface.messageBar().pushMessage(
                    str(self.globalInsee),
                    self.comboBoxAdherent.currentText(),
                    Qgis.Info,
                )
                DlgUtil.update_lineedit_with_value(self.lineEditInsee, self.globalInsee)
                QApplication.setOverrideCursor(Qt.BusyCursor)

                self.update_comboboxes_for_adherent(self.globalInsee, query)
                self.update_treeviews_by_insee(self.globalInsee, query)
                self._lumigis_layers.update_filter_with_insee(self.globalInsee)

                while QApplication.overrideCursor() is not None:
                    QApplication.restoreOverrideCursor()
            elif current_index == 0 and idnom != self.globalAdherent:
                self.clean_adherent_items_and_values(idnom)

    def update_treeviews_by_insee(self, insee, query):
        self.update_treewidgetsupports_by_insee(insee, query)
        self.update_treewidgetappareils_by_insee(insee, query)

    def update_treewidgetsupports_by_insee(self, insee, query):
        # liste des supports de l'adhérent
        self.treeWidgetSupports.clear()
        if query.exec(
            "SELECT id_support, etat FROM supports " f"WHERE insee = {insee} ORDER BY 1"
        ):
            while query.next():
                item = QTreeWidgetItem([query.value("id_support")])
                if item and query.value("etat") in ["A poser", "A remplacer"]:
                    item.setForeground(0, QtGui.QBrush(QtGui.QColor("red")))
                self.treeWidgetSupports.addTopLevelItem(item)
        error = query.lastError()
        if error.isValid():
            print(error.text())
        query.finish()
        if self.treeview_mode in ["numerotation", "detection"]:
            self.treeWidgetSupports.addTopLevelItem(QTreeWidgetItem(["Créer support"]))

        # liste des foyers du support
        if query.prepare(
            "SELECT id_foyer, etat FROM foyers "
            "WHERE insee = ? AND id_support = ? ORDER BY 1"
        ):
            list_objects = self.treeWidgetSupports.findItems(
                self._lumigis_layers.lux_layers[
                    LumigisLayersConst.SUPPORT
                ].regular_expression.pattern(),
                Qt.MatchRegExp or Qt.MatchRecursive,
            )
            for twi in list_objects:
                id_parent = str(twi.data(0, Qt.DisplayRole))
                if id_parent[0:5] != "Créer":
                    query.addBindValue(insee)
                    query.addBindValue(id_parent)
                    if query.exec():
                        while query.next():
                            item = QTreeWidgetItem([query.value("id_foyer")])
                            if item and query.value("etat") in [
                                "A poser",
                                "A remplacer",
                            ]:
                                item.setForeground(0, QtGui.QBrush(QtGui.QColor("red")))
                            twi.addChild(item)
                    error = query.lastError()
                    if error.isValid():
                        print(error.text())
                    query.finish()
                    if self.treeview_mode in ["numerotation", "detection"]:
                        twi.addChild(QTreeWidgetItem(["Créer foyer"]))

        # liste des sources du foyer
        if query.prepare(
            "SELECT numero, etat FROM sources "
            "WHERE insee = ? AND id_foyer = ? ORDER BY 1"
        ):
            for twi in list_objects:
                for i in range(0, twi.childCount()):
                    id_parent = str(twi.child(i).data(0, Qt.DisplayRole))
                    if id_parent[0:5] != "Créer":
                        query.addBindValue(insee)
                        query.addBindValue(id_parent)
                        if query.exec():
                            while query.next():
                                idnom = f'{self._lumigis_layers.lux_layers[LumigisLayersConst.SOURCE].prefix}{query.value("numero")}'
                                item = QTreeWidgetItem([idnom])
                                if item and query.value("etat") in [
                                    "A poser",
                                    "A remplacer",
                                ]:
                                    item.setForeground(
                                        0, QtGui.QBrush(QtGui.QColor("red"))
                                    )
                                twi.child(i).addChild(item)
                        error = query.lastError()
                        if error.isValid():
                            print(error.text())
                        query.finish()
                        if self.treeview_mode == "numerotation":
                            twi.child(i).addChild(QTreeWidgetItem(["Créer source"]))

        self.treeWidgetSupports.hide()
        self.treeWidgetSupports.show()

    def update_treewidgetappareils_by_insee(self, insee, query):
        # liste des armoires de l'adhérent
        self.treeWidgetAppareils.clear()
        if query.prepare(
            "SELECT id_armoire, etat FROM armoires "
            "WHERE insee = ? "
            "ORDER BY length(id_armoire), id_armoire"
        ):
            query.addBindValue(insee)
            if query.exec():
                while query.next():
                    item = QTreeWidgetItem([query.value("id_armoire")])
                    if item and query.value("etat") in ["A poser", "A remplacer"]:
                        item.setForeground(0, QtGui.QBrush(QtGui.QColor("red")))
                    self.treeWidgetAppareils.addTopLevelItem(item)
            error = query.lastError()
            if error.isValid():
                print(error.text())
            query.finish()
            if self.treeview_mode in ["numerotation", "detection"]:
                self.treeWidgetAppareils.addTopLevelItem(
                    QTreeWidgetItem(["Créer armoire"])
                )

        # liste des départs de l'armoire
        if query.prepare(
            "SELECT id_depart, etat FROM departs "
            "WHERE insee = ? AND "
            "id_armoire = ? ORDER BY id_depart"
        ):
            list_objects = self.treeWidgetAppareils.findItems(
                self._lumigis_layers.lux_layers[
                    LumigisLayersConst.ARMOIRE
                ].regular_expression.pattern(),
                Qt.MatchRegExp or Qt.MatchRecursive,
            )
            for twi in list_objects:
                id_parent = str(twi.data(0, Qt.DisplayRole))
                if id_parent[0:5] != "Créer":
                    query.addBindValue(insee)
                    query.addBindValue(id_parent)
                    if query.exec():
                        while query.next():
                            item = QTreeWidgetItem([str(query.value("id_depart"))])
                            if item and query.value("etat") in [
                                "A poser",
                                "A remplacer",
                            ]:
                                item.setForeground(0, QtGui.QBrush(QtGui.QColor("red")))
                            twi.addChild(item)
                    error = query.lastError()
                    if error.isValid():
                        print(error.text())
                    query.finish()
                    if self.treeview_mode in ["numerotation", "detection"]:
                        twi.addChild(QTreeWidgetItem(["Créer départ"]))

        # liste des foyers du départ
        if query.prepare(
            "SELECT id_foyer, etat FROM foyers "
            "WHERE insee = ? AND "
            "id_armoire = ? AND id_depart = ? ORDER BY id_foyer"
        ):
            for twi in list_objects:
                for i in range(0, twi.childCount()):
                    id_parent = str(twi.data(0, Qt.DisplayRole))
                    if id_parent[0:5] != "Créer":
                        query.addBindValue(insee)
                        query.addBindValue(twi.data(0, Qt.DisplayRole))
                        query.addBindValue(str(twi.child(i).data(0, Qt.DisplayRole)))
                        if query.exec():
                            while query.next():
                                item = QTreeWidgetItem([query.value("id_foyer")])
                                if item and query.value("etat") in [
                                    "A poser",
                                    "A remplacer",
                                ]:
                                    item.setForeground(
                                        0, QtGui.QBrush(QtGui.QColor("red"))
                                    )
                                twi.child(i).addChild(item)
                        error = query.lastError()
                        if error.isValid():
                            print(error.text())
                        query.finish()
                        if self.treeview_mode in ["numerotation", "detection"]:
                            twi.child(i).addChild(QTreeWidgetItem(["Créer foyer"]))

        # liste des sources du foyer
        if query.prepare(
            "SELECT numero, etat FROM sources "
            "WHERE insee = ? AND "
            "id_foyer = ? ORDER BY 1"
        ):
            for twi in list_objects:
                for i in range(0, twi.childCount()):
                    for j in range(0, twi.child(i).childCount()):
                        if (
                            str(twi.child(i).child(j).data(0, Qt.DisplayRole))[0:5]
                            != "Créer"
                        ):
                            query.bindValue(0, insee)
                            query.bindValue(
                                1, twi.child(i).child(j).data(0, Qt.DisplayRole)
                            )
                            if query.exec():
                                while query.next():
                                    idnom = f'{self._lumigis_layers.lux_layers[LumigisLayersConst.SOURCE].prefix}{query.value("numero")}'
                                    item = QTreeWidgetItem([idnom])
                                    if item and query.value("etat") in [
                                        "A poser",
                                        "A remplacer",
                                    ]:
                                        item.setForeground(
                                            0, QtGui.QBrush(QtGui.QColor("red"))
                                        )
                                    twi.child(i).child(j).addChild(item)
                            error = query.lastError()
                            if error.isValid():
                                print(error.text())
                            query.finish()
                            if self.treeview_mode == "numerotation":
                                twi.child(i).child(j).addChild(
                                    QTreeWidgetItem(["Créer source"])
                                )

        self.treeWidgetAppareils.hide()
        self.treeWidgetAppareils.show()

        self.currentTreeWidget = self.treeWidgetSupports

    def clean_adherent_items_and_values(self, idnom):
        self.lineEditInsee.clear()
        self.lineEditInsee.update()
        self.treeWidgetSupports.hide()
        self.treeWidgetSupports.clear()
        self.treeWidgetSupports.show()
        self.treeWidgetAppareils.hide()
        self.treeWidgetAppareils.clear()
        self.treeWidgetAppareils.show()
        if idnom == "SDE":
            if (
                "clean_filter_on_closing" in LumigisConfig.gis_config()
                and LumigisConfig.gis_config()["clean_filter_on_closing"]
            ):
                self.globalAdherent = idnom
                self.globalInsee = 0
                self._lumigis_layers.update_filter_with_insee(self.globalInsee)
                iface.messageBar().pushMessage(
                    LumigisConfig.gis_config()["exploitant"], "", Qgis.Info
                )

    def on_combobox_intervention_current_index_changed(self, current_index):
        pass

    def on_combobox_intervention_current_text_changed(self, current_text):
        pass

    def on_tabwidget_supports_appareils_current_changed(self, index):
        # print("tabWidgetSupportsAppareils",index,LumigisLayersConst.SUPPORT, LumigisLayersConst.ARMOIRE)
        if index == LumigisLayersConst.TREEVIEW_SUPPORTS:
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.SUPPORT)
            self.currentTreeWidget = self.treeWidgetSupports
        elif index == LumigisLayersConst.TREEVIEW_APPAREILS:
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.ARMOIRE)
            self.currentTreeWidget = self.treeWidgetAppareils

    def on_treewidgetappareils_selection_changed(self):
        layer = self.iface.activeLayer()
        if layer:
            fids = layer.selectedFeatureIds()
            if fids:
                layer.deselect(fids)
        self.pushButtonRazFiche.setEnabled(False)
        list_objects = self.treeWidgetAppareils.selectedItems()
        if len(list_objects) > 0:
            twi = list_objects[0]
            value = twi.data(0, Qt.DisplayRole)
            self.currentIdnom = value
            self.process_selected_item(twi, self.db_util.query, value)

    def on_treewidgetappareils_expanded(self, widget_item):
        self.collapse_all_but_this_one(widget_item)
        if (
            self._lumigis_layers.lux_layers[LumigisLayersConst.ARMOIRE]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditArmoire_id_armoire, widget_item.text(0)
            )
            self.globalArmoire = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.ARMOIRE].name
                )[0]
            except Exception as e:
                print(str(e))
                pass
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditFoyer_id_foyer, widget_item.text(0)
            )
            self.globalFoyer = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER].name
                )[0]
            except Exception as e:
                print(str(e))
                pass
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.DEPART]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditDepart_id_depart, widget_item.text(0)
            )
            self.globalDepart = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.DEPART].name
                )[0]
            except Exception as e:
                print(str(e))
                pass

    def on_treewidgetsupports_selection_changed(self):
        layer = self.iface.activeLayer()
        if layer:
            fids = layer.selectedFeatureIds()
            if fids:
                layer.deselect(fids)
        self.pushButtonRazFiche.setEnabled(False)
        list_objects = self.treeWidgetSupports.selectedItems()
        if len(list_objects) > 0:
            twi = list_objects[0]
            value = twi.data(0, Qt.DisplayRole)
            self.currentIdnom = value
            self.process_selected_item(twi, self.db_util.query, value)

    def collapse_all_but_this_one(self, widget_item):
        if widget_item.parent() is None:
            if self.collapseOthersItems:
                widget_item.treeWidget().collapseAll()
                self.collapseOthersItems = False
                widget_item.setExpanded(True)
                self.collapseOthersItems = True
        else:
            for i in range(0, widget_item.parent().childCount()):
                if widget_item.parent().child(i).text(0) != widget_item.text(0):
                    widget_item.parent().child(i).setExpanded(False)

    def on_treewidgetsupports_expanded(self, widget_item):
        self.collapse_all_but_this_one(widget_item)
        if (
            self._lumigis_layers.lux_layers[LumigisLayersConst.SUPPORT]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditSupport_id_support, widget_item.text(0)
            )
            self.globalSupport = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.SUPPORT].name
                )[0]
            except Exception as e:
                print(str(e))
                pass
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditFoyer_id_foyer, widget_item.text(0)
            )
            self.globalFoyer = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER].name
                )[0]
            except:
                pass

    def on_combobox_support_type_protection_current_text_changed(self, text):
        if text == "Différentiel":
            self.groupBoxSupportDifferentiel.setEnabled(True)
        else:
            self.groupBoxSupportDifferentiel.setEnabled(False)

    def on_pushbutton_raz_fiche_clicked(self):
        # print("on_pushbutton_raz_fiche_clicked ",
        # self.stackedWidgetFiches.currentIndex())

        if self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.SUPPORT:
            self.raz_fiche_support()

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.ARMOIRE:
            self.raz_fiche_armoire()

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.DEPART:
            self.raz_fiche_depart()

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.FOYER:
            self.raz_fiche_foyer()

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.SOURCE:
            self.raz_fiche_source()

        self.stackedWidgetFiches.currentWidget().update(
            self.stackedWidgetFiches.currentWidget().x(),
            self.stackedWidgetFiches.currentWidget().y(),
            self.stackedWidgetFiches.currentWidget().width(),
            self.stackedWidgetFiches.currentWidget().height(),
        )

    def on_pushbutton_valider_fiche_clicked(self):
        # print("on_pushbutton_valider_fiche_clicked ",
        # self.stackedWidgetFiches.currentIndex())
        self.currentTablename = ""
        self.currentId = 0

        if not self.pushButtonValiderFiche.isEnabled():
            return

        if self.mode == "numerotation":
            self.pushButtonValiderFiche.setEnabled(False)

        if self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.SUPPORT:
            self.insert_or_update_support(self.iface.activeLayer(), self.currentFeature)

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.ARMOIRE:
            self.insert_or_update_armoire(self.iface.activeLayer(), self.currentFeature)

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.DEPART:
            self.insert_or_update_depart(self.iface.activeLayer(), self.currentFeature)

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.FOYER:
            self.insert_or_update_foyer(self.iface.activeLayer(), self.currentFeature)

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.SOURCE:
            self.insert_or_update_source(self.iface.activeLayer(), self.currentFeature)

    def on_pushbutton_install_clicked(self):
        self.currentFeature = FeaUtil.feature_by_insee_and_idnom(
            self.iface.mapCanvas().currentLayer(),
            self._lumigis_layers.lux_layers[
                self.stackedWidgetFiches.currentIndex()
            ].view_col_id,
            self._lumigis_layers.lux_layers[
                self.stackedWidgetFiches.currentIndex()
            ].view_col_insee,
            self.globalInsee,
            self._lumigis_layers.lux_layers[
                self.stackedWidgetFiches.currentIndex()
            ].view_col_idnom,
            self.currentIdnom,
        )
        self.currentId = self.currentFeature.id()
        if self._lumigis_layers.lux_layers[
            self.stackedWidgetFiches.currentIndex()
        ].id in [
            LumigisLayersConst.ARMOIRE,
            LumigisLayersConst.SUPPORT,
            LumigisLayersConst.FOYER,
        ]:
            if self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.SUPPORT:
                self.currentSymbol = self.comboBoxSupport_cellule.currentText()
            elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.FOYER:
                self.currentSymbol = self.comboBoxFoyer_cellule.currentText()
            elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.ARMOIRE:
                self.currentSymbol = "ARMOIRE"
            else:
                self.currentSymbol = None
            attr_values_dict = {"etat": "Actif"}
            if self.currentSymbol:
                attr_values_dict["cellule"] = self.currentSymbol

            self.iface.mapCanvas().zoomToSelected()
            self.iface.mapCanvas().zoomScale(200.0)

            self.place_rotated_point(
                self.stackedWidgetFiches.currentIndex(),
                self._lumigis_layers.lux_layers[
                    self.stackedWidgetFiches.currentIndex()
                ].view_name,
                3,
                self.currentId,
                attr_values_dict,
            )
        else:
            iface.messageBar().pushMessage(
                "Error",
                f"Not a spatial entity ({self.iface.activeLayer().name()})",
                level=Qgis.Warning,
            )

    def is_object_in_widget_unknown(self, text):
        if text == self.idInconnu:
            return True
        else:
            return False

    def update_treewidget_with_new_item(
        self, widget_item, material_index, new_name, name_to_add
    ):
        widget_item.setText(0, new_name)
        self.currentIdnom = new_name
        if widget_item.parent() is None:
            widget_item.treeWidget().addTopLevelItem(QTreeWidgetItem([name_to_add]))
        else:
            widget_item.parent().addChild(QTreeWidgetItem([name_to_add]))
        if self._lumigis_layers.lux_layers[material_index].child_name != "undefined":
            widget_item.addChild(
                QTreeWidgetItem(
                    [self._lumigis_layers.lux_layers[material_index].child_name]
                )
            )

    def find_treewidget_item_by_text(self, regex_pattern, text):
        list_items = self.treeWidgetSupports.findItems(
            regex_pattern,
            Qt.MatchRegExp or Qt.MatchRecursive,
        )
        # for twi in list_objects:
        #    id_parent = str(twi.data(0, Qt.DisplayRole))
        ...

    def process_selected_item(self, widget_item, query, value):
        if (
            self._lumigis_layers.lux_layers[LumigisLayersConst.SUPPORT]
            .regular_expression.match(value)
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(self.lineEditSupport_id_support, value)
            self.globalSupport = value
            self._lumigis_layers.active_layer_by_index(
                "LUX", LumigisLayersConst.SUPPORT
            )
            self.currentFeature = FeaUtil.feature_by_insee_and_idnom(
                self.iface.activeLayer(),
                "numero",
                "insee",
                self.globalInsee,
                "id_support",
                value,
            )
            if self.currentFeature:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_numero_voie,
                    str(self.currentFeature.attribute("numero_voie")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSupport_type_voie,
                    str(self.currentFeature.attribute("type_voie")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_nom_voie,
                    str(self.currentFeature.attribute("nom_voie")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSupport_etat,
                    str(self.currentFeature.attribute("etat")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSupport_cellule,
                    str(self.currentFeature.attribute("cellule")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSupport_nature,
                    str(self.currentFeature.attribute("nature")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_terre,
                    str(self.currentFeature.attribute("terre")),
                )
                DlgUtil.update_checkbox_with_value(
                    self.checkBoxSupport_boitier,
                    str(self.currentFeature.attribute("boitier")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSupport_type_protection,
                    str(self.currentFeature.attribute("type_protection")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_sensibilite_diff,
                    str(self.currentFeature.attribute("sensibilite_diff")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_calibre_diff,
                    str(self.currentFeature.attribute("calibre_diff")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSupport_forme,
                    str(self.currentFeature.attribute("forme")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_marque,
                    str(self.currentFeature.attribute("marque")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_matiere,
                    str(self.currentFeature.attribute("matiere")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_hauteur_totale,
                    str(self.currentFeature.attribute("hauteur_totale")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSupport_type_massif,
                    str(self.currentFeature.attribute("type_massif")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSupport_entraxe_massif,
                    str(self.currentFeature.attribute("entraxe_massif")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_ral_mat,
                    str(self.currentFeature.attribute("ral_mat")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSupport_type_crosse,
                    str(self.currentFeature.attribute("type_crosse")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_ral_crosse,
                    str(self.currentFeature.attribute("ral_crosse")),
                )
                DlgUtil.update_checkbox_with_value(
                    self.checkBoxSupport_prise_illumination,
                    str(self.currentFeature.attribute("prise_illumination")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_ral_illum,
                    str(self.currentFeature.attribute("ral_illum")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_remarque,
                    self.currentFeature.attribute("remarque"),
                )
                self.globalSupportId = self.currentFeature.attribute("numero")
                self.groupBoxSupport.setTitle("Support #" + str(self.globalSupportId))
                iface.activeLayer().selectByExpression(
                    '"numero"=' + str(self.globalSupportId),
                    QgsVectorLayer.SetSelection,
                )
            else:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSupport_id_support, self.idInconnu
                )
                self.globalSupport = self.idInconnu
                self.globalSupportId = 0
                self.groupBoxSupport.setTitle("Support")
                iface.activeLayer().selectByExpression(
                    '"numero"=' + str(self.globalSupportId), QgsVectorLayer.SetSelection
                )
                if self.treeview_mode == "numerotation":
                    DlgUtil.update_combobox_with_value(
                        self.comboBoxSupport_etat, "A poser"
                    )

            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.SUPPORT)
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.ARMOIRE]
            .regular_expression.match(value)
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(self.lineEditArmoire_id_armoire, value)
            self.globalArmoire = value
            self._lumigis_layers.active_layer_by_index(
                "LUX", LumigisLayersConst.ARMOIRE
            )
            self.currentFeature = FeaUtil.feature_by_insee_and_idnom(
                self.iface.activeLayer(),
                "numero",
                "insee",
                self.globalInsee,
                "id_armoire",
                value,
            )
            if self.currentFeature:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditArmoire_numero_voie,
                    str(self.currentFeature.attribute("numero_voie")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxArmoire_type_voie,
                    str(self.currentFeature.attribute("type_voie")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditArmoire_nom_voie,
                    str(self.currentFeature.attribute("nom_voie")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxArmoire_etat,
                    str(self.currentFeature.attribute("etat")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditArmoire_enveloppe_poste_amont,
                    str(self.currentFeature.attribute("enveloppe_poste_amont")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxArmoire_enveloppe_pose,
                    str(self.currentFeature.attribute("enveloppe_pose")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxArmoire_vetuste,
                    str(self.currentFeature.attribute("vetuste")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxArmoire_fermeture,
                    str(self.currentFeature.attribute("fermeture")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditArmoire_nbre_depart,
                    str(self.currentFeature.attribute("nbre_depart")),
                )
                self.globalArmoireId = self.currentFeature.attribute("numero")
                self.groupBoxArmoire.setTitle("Armoire #" + str(self.globalArmoireId))
                iface.activeLayer().selectByExpression(
                    '"numero"=' + str(self.globalArmoireId),
                    QgsVectorLayer.SetSelection,
                )
            else:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditArmoire_id_armoire, self.idInconnu
                )
                self.globalArmoire = self.idInconnu
                self.globalArmoireId = 0
                self.groupBoxArmoire.setTitle("Armoire")
                iface.activeLayer().selectByExpression(
                    '"numero"=' + str(self.globalArmoireId), QgsVectorLayer.SetSelection
                )
                if self.treeview_mode == "numerotation":
                    DlgUtil.update_combobox_with_value(
                        self.comboBoxArmoire_etat, "A poser"
                    )

            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.ARMOIRE)
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.DEPART]
            .regular_expression.match(value)
            .hasMatch()
        ):
            # print("depart")
            DlgUtil.update_lineedit_with_value(self.lineEditDepart_id_depart, value)
            self.globalDepart = value
            self._lumigis_layers.active_layer_by_index("LUX", LumigisLayersConst.DEPART)
            self.currentFeature = FeaUtil.feature_by_insee_and_idnom(
                self.iface.activeLayer(),
                "numero",
                "insee",
                self.globalInsee,
                "id_depart",
                value,
            )
            if self.currentFeature:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditDepart_id_armoire,
                    str(self.currentFeature.attribute("id_armoire")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxDepart_nature_depart,
                    str(self.currentFeature.attribute("nature_depart")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditDepart_iphase1,
                    str(self.currentFeature.attribute("iphase1")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditDepart_iphase2,
                    str(self.currentFeature.attribute("iphase2")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditDepart_iphase3,
                    str(self.currentFeature.attribute("iphase3")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxDepart_designation,
                    str(self.currentFeature.attribute("designation")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxDepart_nature_protection,
                    str(self.currentFeature.attribute("nature_protection")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditDepart_calibrage_protection,
                    str(self.currentFeature.attribute("calibrage_protection")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditDepart_depart_sens_diff,
                    str(self.currentFeature.attribute("depart_sens_diff")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditDepart_pilote,
                    str(self.currentFeature.attribute("pilote")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxDepart_regime_allumage,
                    str(self.currentFeature.attribute("regime_allumage")),
                )
                DlgUtil.update_timeedit_with_value(
                    self.timeEditDepart_heure_allumage,
                    self.currentFeature.attribute("heure_allumage"),
                )
                DlgUtil.update_timeedit_with_value(
                    self.timeEditDepart_heure_extinction,
                    self.currentFeature.attribute("heure_extinction"),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxDepart_etat, str(self.currentFeature.attribute("etat"))
                )
                self.globalDepartId = self.currentFeature.attribute("numero")
                self.groupBoxDepart.setTitle("Départ #" + str(self.globalDepartId))
                iface.activeLayer().selectByExpression(
                    '"numero"=' + str(self.globalDepartId),
                    QgsVectorLayer.SetSelection,
                )
                if query.exec(
                    "SELECT numero FROM armoires a JOIN departs d "
                    " ON a.id_armoire = d.id_armoire"
                    "WHERE numero = {}".format(self.globalDepartId)
                ):
                    if query.first():
                        self.globalArmoireId = query.value(0)
            else:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditDepart_id_depart, self.idInconnu
                )
                self.globalDepart = self.idInconnu
                self.globalDepartId = 0
                self.groupBoxDepart.setTitle("Départ #" + str(self.globalDepartId))
                if widget_item.parent() is not None:
                    DlgUtil.update_lineedit_with_value(
                        self.lineEditDepart_id_armoire, widget_item.parent().text(0)
                    )
                if self.treeview_mode == "numerotation":
                    DlgUtil.update_combobox_with_value(
                        self.comboBoxDepart_etat, "A poser"
                    )

            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.DEPART)
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER]
            .regular_expression.match(value)
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(self.lineEditFoyer_id_foyer, value)
            self.globalFoyer = value
            self._lumigis_layers.active_layer_by_index("LUX", LumigisLayersConst.FOYER)
            self.currentFeature = FeaUtil.feature_by_insee_and_idnom(
                self.iface.activeLayer(),
                "numero",
                "insee",
                self.globalInsee,
                "id_foyer",
                value,
            )
            if self.currentFeature:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_id_support,
                    str(self.currentFeature.attribute("id_support")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_id_armoire,
                    str(self.currentFeature.attribute("id_armoire")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_id_depart,
                    str(self.currentFeature.attribute("id_depart")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxFoyer_etat, str(self.currentFeature.attribute("etat"))
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxFoyer_cellule,
                    str(self.currentFeature.attribute("cellule")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxFoyer_num_phase,
                    str(self.currentFeature.attribute("num_phase")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_hauteur_feu,
                    str(self.currentFeature.attribute("hauteur_feu")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_marque,
                    str(self.currentFeature.attribute("marque")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_type_vasque,
                    str(self.currentFeature.attribute("type_vasque")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_classe_electrique,
                    str(self.currentFeature.attribute("classe_electrique")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_degre_protection,
                    str(self.currentFeature.attribute("degre_protection")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_resistance_choc,
                    str(self.currentFeature.attribute("resistance_choc")),
                )
                DlgUtil.update_checkbox_with_value(
                    self.checkBoxFoyer_varistance,
                    str(self.currentFeature.attribute("varistance")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_ral, str(self.currentFeature.attribute("ral"))
                )
                self.globalFoyerId = self.currentFeature.attribute("numero")
                self.groupBoxFoyer.setTitle("Foyer #" + str(self.globalFoyerId))
                iface.activeLayer().selectByExpression(
                    '"numero"=' + str(self.globalFoyerId),
                    QgsVectorLayer.SetSelection,
                )
            else:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditFoyer_id_foyer, self.idInconnu
                )
                self.globalFoyer = self.idInconnu
                if self.treeview_mode == "numerotation":
                    DlgUtil.update_combobox_with_value(
                        self.comboBoxFoyer_etat, "A poser"
                    )
                self.globalFoyerId = 0
                self.groupBoxFoyer.setTitle("Foyer")
                iface.activeLayer().selectByExpression(
                    '"numero"=' + str(self.globalFoyerId), QgsVectorLayer.SetSelection
                )
                if widget_item.parent() is not None:
                    if (
                        self._lumigis_layers.lux_layers[LumigisLayersConst.DEPART]
                        .regular_expression.match(widget_item.parent().text(0))
                        .hasMatch()
                    ):
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditFoyer_id_depart, widget_item.parent().text(0)
                        )
                        if widget_item.parent().parent() is not None:
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_id_armoire,
                                widget_item.parent().parent().text(0),
                            )
                    elif (
                        self._lumigis_layers.lux_layers[LumigisLayersConst.SUPPORT]
                        .regular_expression.match(widget_item.parent().text(0))
                        .hasMatch()
                    ):
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditFoyer_id_support, widget_item.parent().text(0)
                        )
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.FOYER)
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.SOURCE]
            .regular_expression.match(value)
            .hasMatch()
        ):
            # print(value)
            DlgUtil.update_lineedit_with_value(self.lineEditSource_id_source, value)
            self._lumigis_layers.active_layer_by_index("LUX", LumigisLayersConst.SOURCE)
            self.currentFeature = FeaUtil.feature_by_insee_and_idnom(
                self.iface.activeLayer(),
                "numero",
                "insee",
                self.globalInsee,
                "id_support",
                value,
            )
            if self.currentFeature:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSource_id_foyer,
                    str(self.currentFeature.attribute("id_foyer")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSource_etat, str(self.currentFeature.attribute("etat"))
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSource_temperature_couleur,
                    str(self.currentFeature.attribute("temperature_couleur")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSource_localisation_appareillage,
                    str(self.currentFeature.attribute("localisation_appareillage")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSource_photometrie,
                    str(self.currentFeature.attribute("photometrie")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSource_nature,
                    str(self.currentFeature.attribute("nature")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSource_puissance,
                    str(self.currentFeature.attribute("puissance")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSource_intensite_alim,
                    str(self.currentFeature.attribute("intensite_alim")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSource_culot,
                    str(self.currentFeature.attribute("culot")),
                )
                DlgUtil.update_combobox_with_value(
                    self.comboBoxSource_appareillage,
                    str(self.currentFeature.attribute("appareillage")),
                )
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSource_flux, str(self.currentFeature.attribute("flux"))
                )
                DlgUtil.update_checkbox_with_value(
                    self.checkBoxSource_parafoudre,
                    str(self.currentFeature.attribute("parafoudre")),
                )
                DlgUtil.update_checkbox_with_value(
                    self.checkBoxSource_abaissement_puissance,
                    str(self.currentFeature.attribute("abaissement_puissance")),
                )
                self.globalSourceId = self.currentFeature.attribute("numero")
                self.groupBoxSource.setTitle("Source #" + str(self.globalSourceId))
                iface.activeLayer().selectByExpression(
                    '"numero"=' + str(self.globalSourceId),
                    QgsVectorLayer.SetSelection,
                )
            else:
                DlgUtil.update_lineedit_with_value(
                    self.lineEditSource_id_source, self.idInconnu
                )
                DlgUtil.update_combobox_with_value(self.comboBoxSource_etat, "A poser")
                self.globalSourceId = 0
                self.groupBoxSource.setTitle("Source")
                iface.activeLayer().selectByExpression(
                    '"numero"=' + str(self.globalSourceId), QgsVectorLayer.SetSelection
                )
                if widget_item.parent() is not None:
                    DlgUtil.update_lineedit_with_value(
                        self.lineEditSource_id_foyer, widget_item.parent().text(0)
                    )
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.SOURCE)
        else:
            iface.messageBar().pushMessage(
                "Error", f"Item indéterminé ({value})", level=Qgis.Warning
            )

    def raz_fiche_support(self):
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_numero_voie, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_type_voie, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_nom_voie, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_etat, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_nature, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_terre, "")
        DlgUtil.update_checkbox_with_value(self.checkBoxSupport_boitier, False)
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_type_protection, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_sensibilite_diff, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_calibre_diff, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_forme, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_marque, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_matiere, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_hauteur_totale, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_type_massif, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_entraxe_massif, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_ral_mat, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_type_crosse, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_ral_crosse, "")
        DlgUtil.update_checkbox_with_value(
            self.checkBoxSupport_prise_illumination, False
        )
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_ral_illum, "")
        self.globalSupportId = 0

        DlgUtil.update_lineedit_with_value(
            self.lineEditSupport_id_support, self.idInconnu
        )
        self.globalSupport = self.idInconnu
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_etat, "A poser")

    def raz_fiche_armoire(self):
        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_numero_voie, "")
        DlgUtil.update_combobox_with_value(self.comboBoxArmoire_type_voie, "")
        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_nom_voie, "")
        DlgUtil.update_combobox_with_value(self.comboBoxArmoire_etat, "")
        DlgUtil.update_lineedit_with_value(
            self.lineEditArmoire_enveloppe_poste_amont, ""
        )
        DlgUtil.update_combobox_with_value(self.comboBoxArmoire_enveloppe_pose, "")
        DlgUtil.update_combobox_with_value(self.comboBoxArmoire_vetuste, "")
        DlgUtil.update_combobox_with_value(self.comboBoxArmoire_fermeture, "")
        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_nbre_depart, "")
        self.globalArmoireId = 0

        DlgUtil.update_lineedit_with_value(
            self.lineEditArmoire_id_armoire, self.idInconnu
        )
        self.globalArmoire = self.idInconnu

    # DlgUtil.update_combobox_with_value(self.comboBoxArmoire_etat,
    # "A poser")

    def raz_fiche_depart(self):
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_id_armoire, "")
        DlgUtil.update_combobox_with_value(self.comboBoxDepart_nature_depart, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_iphase1, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_iphase2, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_iphase3, "")
        DlgUtil.update_combobox_with_value(self.comboBoxDepart_designation, "")
        DlgUtil.update_combobox_with_value(self.comboBoxDepart_nature_protection, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_calibrage_protection, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_depart_sens_diff, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_pilote, "")
        DlgUtil.update_combobox_with_value(self.comboBoxDepart_regime_allumage, "")
        DlgUtil.update_timeedit_with_value(
            self.timeEditDepart_heure_allumage, QTime.fromString("00:00")
        )
        DlgUtil.update_timeedit_with_value(
            self.timeEditDepart_heure_extinction, QTime.fromString("00:00")
        )
        self.globalDepartId = 0

        DlgUtil.update_lineedit_with_value(
            self.lineEditDepart_id_depart, self.idInconnu
        )
        self.globalDepart = self.idInconnu

    # DlgUtil.update_combobox_with_value(self.comboBoxDepart_etat,
    # "A poser")

    def raz_fiche_foyer(self):
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_id_support, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_id_armoire, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_id_depart, "")
        DlgUtil.update_combobox_with_value(self.comboBoxFoyer_etat, "")
        DlgUtil.update_combobox_with_value(self.comboBoxFoyer_num_phase, "1")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_hauteur_feu, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_marque, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_type_vasque, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_classe_electrique, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_degre_protection, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_resistance_choc, "")
        DlgUtil.update_checkbox_with_value(self.checkBoxFoyer_varistance, False)
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_ral, "")
        self.globalFoyerId = 0

        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_id_foyer, self.idInconnu)
        self.globalFoyer = self.idInconnu
        if self.treeview_mode == "numerotation":
            DlgUtil.update_combobox_with_value(self.comboBoxFoyerEtat, "A poser")

    def raz_fiche_source(self):
        DlgUtil.update_lineedit_with_value(self.lineEditSource_id_foyer, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSource_etat, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_temperature_couleur, "")
        DlgUtil.update_combobox_with_value(
            self.comboBoxSource_localisation_appareillage, ""
        )
        DlgUtil.update_combobox_with_value(self.comboBoxSource_photometrie, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSource_nature, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_puissance, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_intensite_alim, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSource_culot, "")
        DlgUtil.update_combobox_with_value(self.comboBoxSource_appareillage, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_flux, "")
        DlgUtil.update_checkbox_with_value(self.checkBoxSource_parafoudre, False)
        DlgUtil.update_checkbox_with_value(
            self.checkBoxSource_abaissement_puissance, False
        )
        self.globalSourceId = 0

        DlgUtil.update_lineedit_with_value(
            self.lineEditSource_id_source, self.idInconnu
        )
        DlgUtil.update_combobox_with_value(self.comboBoxSource_etat, "A poser")

    # ----------------- db requests -------------------------------------------------

    def insert_or_update_support(self, layer, feature):
        try:
            with edit(layer):
                feature_dict = {}
                old_dico = {}
                value = self.comboBoxSupport_etat.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "etat", value
                )
                value = self.comboBoxSupport_cellule.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "cellule", value
                )
                value = self.lineEditSupport_numero_voie.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "numero_voie", value
                )
                value = self.lineEditSupport_terre.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "terre", value
                )
                value = "oui" if self.checkBoxSupport_boitier.isChecked() else "non"
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "boitier", value
                )
                value = self.comboBoxSupport_type_protection.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "type_protection", value
                )
                value = self.lineEditSupport_sensibilite_diff.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "sensibilite_diff", value
                )
                value = self.lineEditSupport_calibre_diff.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "calibre_diff", value
                )
                value = self.comboBoxSupport_type_massif.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "type_massif", value
                )
                value = self.comboBoxSupport_entraxe_massif.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "entraxe_massif", value
                )
                value = (
                    "oui"
                    if self.checkBoxSupport_prise_illumination.isChecked()
                    else "non"
                )
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "prise_illumination", value
                )
                value = self.lineEditSupport_remarque.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "remarque", value
                )
                layer.changeAttributeValues(feature.id(), feature_dict, old_dico)
        except QgsEditError as e:
            print(repr(e))

    def insert_or_update_armoire(self, layer, feature):
        try:
            with edit(layer):
                feature_dict = {}
                old_dico = {}
                value = self.comboBoxArmoire_etat.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "etat", value
                )
                value = self.comboBoxArmoire_vetuste.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "vetuste", value
                )
                value = self.comboBoxArmoire_fermeture.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "fermeture", value
                )
                value = self.comboBoxArmoire_enveloppe_pose.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "enveloppe_pose", value
                )
                value = self.lineEditArmoire_numero_voie.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "numero_voie", value
                )
                value = self.lineEditArmoire_remarque.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "remarque", value
                )
                layer.changeAttributeValues(feature.id(), feature_dict, old_dico)
        except QgsEditError as e:
            print(repr(e))

    def insert_or_update_depart(self, layer, feature):
        try:
            with edit(layer):
                feature_dict = {}
                old_dico = {}
                value = self.comboBoxDepart_etat.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "etat", value
                )
                value = self.comboBoxDepart_nature_depart.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "nature_depart", value
                )
                value = self.lineEditDepart_iphase1.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "iphase1", value
                )
                value = self.lineEditDepart_iphase2.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "iphase2", value
                )
                value = self.lineEditDepart_iphase3.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "iphase3", value
                )
                value = self.comboBoxDepart_designation.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "designation", value
                )
                value = self.comboBoxDepart_nature_protection.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "nature_protection", value
                )
                value = self.lineEditDepart_calibrage_protection.text()
                FeaUtil.add_changed_attribute_value(
                    layer,
                    feature,
                    feature_dict,
                    old_dico,
                    "calibrage_protection",
                    value,
                )
                value = self.lineEditDepart_depart_sens_diff.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "depart_sens_diff", value
                )
                value = self.timeEditDepart_heure_allumage.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "heure_allumage", value
                )
                value = self.timeEditDepart_heure_extinction.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "heure_extinction", value
                )
                value = self.comboBoxDepart_regime_allumage.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "regime_allumage", value
                )
                value = self.lineEditDepart_pilote.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "pilote", value
                )
                value = self.lineEditDepart_remarque.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "remarque", value
                )
                layer.changeAttributeValues(feature.id(), feature_dict, old_dico)
        except QgsEditError as e:
            print(repr(e))

    def insert_or_update_foyer(self, layer, feature):
        try:
            with edit(layer):
                feature_dict = {}
                old_dico = {}
                value = self.comboBoxFoyer_etat.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "etat", value
                )
                value = self.comboBoxFoyer_cellule.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "cellule", value
                )
                value = self.comboBoxFoyer_num_phase.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "num_phase", value
                )
                value = self.lineEditFoyer_remarque.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "remarque", value
                )
                layer.changeAttributeValues(feature.id(), feature_dict, old_dico)
        except QgsEditError as e:
            print(repr(e))

    def insert_or_update_source(self, layer, feature):
        try:
            with edit(layer):
                feature_dict = {}
                old_dico = {}
                value = self.comboBoxSource_etat.currentText()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "etat", value
                )
                value = self.lineEditSource_remarque.text()
                FeaUtil.add_changed_attribute_value(
                    layer, feature, feature_dict, old_dico, "remarque", value
                )
                layer.changeAttributeValues(feature.id(), feature_dict, old_dico)
        except QgsEditError as e:
            print(repr(e))

    def validate_and_add_bind_value(self, query, value, empty_string=False):
        # print(type(value),value)
        if isinstance(value, str):
            if empty_string and value == "":
                query.addBindValue(value)
            elif value == "" or value == "NULL" or value is None:
                query.addBindValue(QVariant(QVariant.String))
            else:
                query.addBindValue(value)
        elif isinstance(value, bool):
            if value is None:
                query.addBindValue(QVariant(QVariant.String))
            else:
                if value:
                    query.addBindValue("oui")
                elif value:
                    query.addBindValue("non")
                else:
                    query.addBindValue(QVariant(QVariant.String))
        elif isinstance(value, int):
            if value is None:
                query.addBindValue(QVariant(QVariant.Int))
            else:
                query.addBindValue(value)
        else:
            # print("TO DO ...",value)
            self.iface.messageBar().pushMessage(
                "validate_and_add_bind_value", "TO DO... " + value, Qgis.Warning
            )

    def load_comboboxes(self):
        try:
            # liste des collectivités adhérentes
            DlgUtil.load_combobox_list(
                self.comboBoxAdherent,
                self.db_util.query,
                "SELECT value_data FROM metadata WHERE key_data = 'COMMUNE'",
            )

            # intervention
            DlgUtil.load_combobox_list(
                self.comboBoxIntervention,
                self.db_util.query,
                "SELECT value_data FROM metadata WHERE key_data = 'INTERVENTION'",
                False,
            )

            query = self.db_util.query
            if query:
                sql = "SELECT value_data FROM metadata WHERE key_data = 'DESCRIPTION'"
                if query.exec(sql):
                    if query.first():
                        self.labelDescriptionIntervention.setText(
                            query.value("value_data")
                        )

            # comboBoxes supports
            DlgUtil.load_combobox_list_array(
                self.comboBoxSupport_etat,
                [
                    "Actif",
                    "A poser",
                    "Virtuel",
                    "Inactif",
                    "A remplacer",
                    "A déposer",
                    "Déposé",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSupport_cellule,
                [
                    "CARRE FER",
                    "MAT BOULE",
                    "MAT DOUBLE",
                    "MAT QUADRUPLE",
                    "MAT SIMPLE",
                    "MAT TRIPLE",
                    "POTEAU BETON",
                    "POTEAU BOIS",
                    "POTEAU BOIS CONTREFICHE",
                    "POTEAU BOIS DOUBLE",
                    "SUPPORT A POSER",
                    "SUPPORT FACADE",
                    "SUPPORT PROJECTEUR",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSupport_nature,
                [
                    "béton",
                    "bois",
                    "borne",
                    "mât",
                    "projecteur",
                    "top",
                    "façade",
                    "balisage",
                    "carré fer",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSupport_type_protection, ["Différentiel", "Fusible"]
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSupport_forme,
                ["Octogonal", "Cylindrique", "Cylindro-conique" "Autre"],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSupport_type_massif, ["Coulé", "Préfabriqué"]
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSupport_entraxe_massif,
                ["200 x 200", "300 x 300", "320 x 320", "330 x 330"],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSupport_type_crosse,
                ["Simple", "Double", "Triple", "Quadruple", "Top"],
            )

            # comboBoxes armoires
            DlgUtil.load_combobox_list_array(
                self.comboBoxArmoire_etat,
                [
                    "Actif",
                    "A poser",
                    "Virtuel",
                    "Inactif",
                    "A remplacer",
                    "A déposer",
                    "Déposé",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxArmoire_enveloppe_pose,
                [
                    "Saillie",
                    "Encastrée",
                    "Sur poteau de distribution",
                    "Sur façade",
                    "Autre",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxArmoire_vetuste, ["Bon", "Moyen", "Vétuste"]
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxArmoire_fermeture, ["Clés", "Triangle", "Plat"]
            )

            # comboboxes departs
            DlgUtil.load_combobox_list_array(
                self.comboBoxDepart_etat,
                [
                    "Actif",
                    "A poser",
                    "Virtuel",
                    "Inactif",
                    "A remplacer",
                    "A déposer",
                    "Déposé",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxDepart_designation,
                ["Eclairage public", "Illumination", "Autre"],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxDepart_nature_depart, ["Monophasé", "Triphasé"]
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxDepart_nature_protection,
                [
                    "Fusible",
                    "Disjoncteur",
                    "Disjoncteur différentiel",
                    "interdifférentiel et fusible",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxDepart_regime_allumage,
                ["Gradation", "Permanent", "Semi-permanent", "Autre"],
            )

            # comboboxes foyers
            DlgUtil.load_combobox_list_array(
                self.comboBoxFoyer_etat,
                [
                    "Actif",
                    "A poser",
                    "Virtuel",
                    "Inactif",
                    "A remplacer",
                    "A déposer",
                    "Déposé",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxFoyer_cellule,
                [
                    "FOYER A POSER",
                    "FOYER MAT",
                    "FOYER SIMPLE",
                    "PROJECTEUR",
                ],
            )

            # comboboxes sources
            DlgUtil.load_combobox_list_array(
                self.comboBoxSource_etat,
                [
                    "Actif",
                    "A poser",
                    "Virtuel",
                    "Inactif",
                    "A remplacer",
                    "A déposer",
                    "Déposé",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSource_localisation_appareillage,
                ["Luminaire", "Pied de mât", "Déporté autre"],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSource_photometrie,
                [
                    "Routier",
                    "Symétrique",
                    "Asymétrique",
                    "Circulaire",
                    "ERS",
                    "ERL",
                    "ERE",
                    "LRL",
                    "PFA",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSource_nature,
                [
                    "Iodure métallique",
                    "Sodium basse pression",
                    "Sodium haute pression",
                    "Ballon fluo",
                    "Tube fluo",
                    "Led",
                    "Fluo compacte",
                    "Cosmopolis",
                    "Halogène",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSource_culot,
                [
                    "2G7",
                    "Autre",
                    "B22",
                    "Ba20d",
                    "Ba20s",
                    "E27",
                    "E40",
                    "G12",
                    "G13",
                    "G24d",
                    "G5",
                    "GU5.3",
                    "PG12",
                    "PGz12",
                    "R7s",
                    "RX7s",
                    "S14S",
                    "S19",
                    "SFC10",
                ],
            )
            DlgUtil.load_combobox_list_array(
                self.comboBoxSource_appareillage,
                [
                    "Ballast ferromagnétique",
                    "Ballast électronique",
                    "Ballast graduable",
                ],
            )
        except Exception as e:
            print(str(e))
            pass

    def place_rotated_point(
        self,
        object_type,
        table_name="",
        coord_dimension=3,
        object_id=0,
        attr_values_dict=dict(),
    ):
        if object_type in [
            LumigisLayersConst.ARMOIRE,
            LumigisLayersConst.SUPPORT,
            LumigisLayersConst.FOYER,
        ]:
            # self.active_layer_by_name("Accessoires")
            self.point_tool = PlacePointTool(
                self.iface,
                self.db_util,
                self._lumigis_layers,
                object_type,
                table_name,
                coord_dimension,
                object_id,
                rot90=True,
            )
            self.point_tool.set_attr_values_dict(attr_values_dict)
            self.iface.mapCanvas().setMapTool(self.point_tool)
            global __lumigis_global__
            __lumigis_global__.event_filter.set_current_tool(self.point_tool)
